<id>
Search for IP Address for YaBB 2.4
</id>

<version>
1.1a
</version>

<mod info>
This mod allows Admins and Gmods (if allowed) to search the entire forum for posts that were posted or edited by a certain IP address.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ModList.pl
Languages/English/Search.lng
Sources/Search.pl

History
-------
### YaBB 2.4 - Derek Barnstorm ###
ver 1.0 - Updated for YaBB 2.4 - 10th August 2009
ver 1.0a - Fixed ip.gif image not showing in old 2.1 template and moved highlight feature to its correct sub - 11th August 2009
ver 1.1 - Fixed issue with Gmods being able to search for IP if they don't have permission to view IP's - 10th November 2009
ver 1.1a - Corrected image syntax - 10th November 2009

### YaBB 2.1 - astro-pilot ###
ver 1.0 - Original Update - 27th July 2005
ver 1.0a - Update to Y2 Final Release
ver 1.1 - Fixed error that allowed no admin or gmods to view IP addresses. Thanks Jet Li.

Note:  This is an update of a version originally released (to my knowledge) for YaBB 1.3 by KevinST. (I considered the original mod abandoned since there was no support thread found on Boardmod.org AND since KevinST last posted to that forum in 2003).
</mod info>

<author>
astro-pilot
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$search_for_ip_mod = "Search for IP Address|astro-pilot|This mod allows Admins and Gmods (if allowed) to search the entire forum for posts that were posted or edited by a certain IP address.|1.1a|10th November 2009";
	push (@installed_mods, "$search_for_ip_mod");
</add before>

<edit file>
Languages/English/Search.lng
</edit file>

<search for>
'72' => 'Message',
</search for>

<add after>
'73' => 'IP Address',
</add after>

<edit file>
Sources/Search.pl
</edit file>

<search for>
			<input type="checkbox" name="msgfield" id="msgfield" value="on" checked="checked" /><label for="msgfield"> $search_txt{'72'}</label>
</search for>

<replace>
			<input type="checkbox" name="msgfield" id="msgfield" value="on" checked="checked" /><label for="msgfield"> $search_txt{'72'}</label> &nbsp;~; ## Search for IP Address edit
            ## Search for IP Address start
            if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on"){
                $yymain .= qq~
          	        <input type="checkbox" name="search_ip" id="search_ip" value="on" /><label for="search_ip"> $search_txt{'73'}</label>~;
            }
            ## Search for IP Address end
            ## Search for IP Address added next line
            $yymain .= qq~
</replace>

<search for>
	my $searchmessage = $FORM{'msgfield'} eq 'on';
</search for>

<add after>
	## Search for IP Address start
	if ($FORM{'search_ip'} eq 'on') { $search_ip = $FORM{'search'}; }
	## Search for IP Address end
</add after>

<search for>
				unless ($msgfound || $subfound) { next postcheck; }
</search for>

<replace>
				## Search for IP Address start
				if ($search_ip && !$msgfound && !$subfound) {
					$ipfound = 0;
					if ($mip =~ /\b$search_ip/) {
					    $ipfound = "1";
					}
				}
				## Search for IP Address end
				unless ($msgfound || $subfound || ($ipfound == 1)) { next postcheck; } ## Search for IP Address edit
</replace>

<search for>
		&Highlight(\$msub,\$message,\@search,$case);
</search for>

<replace>
		&Highlight(\$msub,\$message,\$mip,\@search,$case); ## Search for IP Address edit
</replace>

<search for>
		<td align="left" height="80" colspan="2" class="windowbg2" valign="top"><div style="float: left; width: 99%; overflow: auto;">$message</div></td>
</search for>

<replace>
		<td align="left" height="80" colspan="2" class="windowbg2" valign="top"><div style="float: left; width: 99%; overflow: auto;">$message~;
        ## Search for IP Address start
        if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { 
            $yymain .= qq~ 
            <table width="100%">
              <tr>
                <td colspan="2" class="windowbg2" align="right" valign="bottom">
                <br />
                <hr class="hr" />
                <img src="$imagesdir/ip.gif" alt="" border="0" style="vertical-align: middle;" /><span class="small"> $mip</span>
                </td>
              </tr>
           </table>
          </div></td>~; }
        ## Search for IP Address end
        ## Search for IP Address added next line
    $yymain .= qq~
</replace>

<search for>
	my ($msub,$message,$search,$case) = @_;
</search for>

<replace>
	my ($msub,$message,$mip,$search,$case) = @_; ## Search for IP Address edit
</replace>

<search for>
			if ($searchtype == 4) {
				$$msub =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~g;
				$$message =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~g;
			} else {
				$$msub =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~g;
				$$message =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~g;
			}
		} else {
			if ($searchtype == 4) {
				$$msub =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~ig;
				$$message =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~ig;
			} else {
				$$msub =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~ig;
				$$message =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~ig;
			}
</search for>

<replace>
			if ($searchtype == 4) {
				$$msub =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~g;
				$$message =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~g;
				$$mip =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~g; ## Search for IP Address edit
			} else {
				$$msub =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~g;
				$$message =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~g;
				$$mip =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~g; ## Search for IP Address edit
			}
		} else {
			if ($searchtype == 4) {
				$$msub =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~ig;
				$$message =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~ig;
				$$mip =~ s~(\Q$tmp\E)~<span class="highlight">$1</span>~ig; ## Search for IP Address edit
			} else {
				$$msub =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~ig;
				$$message =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~ig;
				$$mip =~ s~(^|\W|_)(\Q$tmp\E)(?=$|\W|_)~$1<span class="highlight">$2</span>$3~ig; ## Search for IP Address edit
			}
</replace>